# JOB DEFINITIONS
Build_C_Question_Bin_Hex_Str_to_Int:
  image:
    name: registry.gitlab.com/90cos/cyv/eval-systems/vscode-server-deploy/90cos-vscode-server:latest
    entrypoint: [""]  # Added to prevent the "unknown option -c" error that occasionally occurs
  stage: build
  variables:
    TB_PATH: !reference [.c_update_path_and_get_google_test, variables, TB_PATH]
    GOOGLE_TEST: !reference [.c_update_path_and_get_google_test, variables, GOOGLE_TEST]
    C_PATH: C_Programming/bin_hex_string_to_integer
  script:
    - !reference [.c_build_compile_code_template, script]
  artifacts:
    paths:
      - ${C_PATH}/build/release/TestCode
      - $TB_PATH/$C_PATH/build/release/TestCode
    expire_in: 1 day
  rules:
    - if: $DEV == 'false'
      when: never
    - if: $DEV == 'true' && $UNIT_TEST_GROUP == "bridge_1"
      when: always
    - if: '$CI_PROJECT_NAME != "basic-dev"'
    - if: $CI_PROJECT_NAME == "basic-dev" && $UNIT_TEST_GROUP == "bridge_1"
      changes:
      - $TEST_BANK_PATH/C_Programming/bin_hex_string_to_integer/**/*
      - "$EVAL_FILES_DIR/**/*"
      - "global_job_templates.yml"

Test_C_Question_Bin_Hex_Str_to_Int:
  image:
    name: registry.gitlab.com/90cos/cyv/eval-systems/vscode-server-deploy/90cos-vscode-server:latest
    entrypoint: [""]  # Added to prevent the "unknown option -c" error that occasionally occurs
  stage: test
  variables:
    TB_PATH: !reference [.c_update_path_and_get_google_test, variables, TB_PATH]
    GOOGLE_TEST: !reference [.c_update_path_and_get_google_test, variables, GOOGLE_TEST]
    C_PATH: C_Programming/bin_hex_string_to_integer
  needs:
    - Build_C_Question_Bin_Hex_Str_to_Int
  script:
    - !reference [.c_run_unit_tests_template, script]
  rules:
    - if: $DEV == 'false'
      when: never
    - if: $DEV == 'true' && $UNIT_TEST_GROUP == "bridge_1"
      when: always
    - if: '$CI_PROJECT_NAME != "basic-dev"'
    - if: $CI_PROJECT_NAME == "basic-dev" && $UNIT_TEST_GROUP == "bridge_1"
      changes:
      - $TEST_BANK_PATH/C_Programming/bin_hex_string_to_integer/**/*
      - "$EVAL_FILES_DIR/**/*"
      - "global_job_templates.yml"

Build_C_Question_Bin_Hex_Str_to_Int_Ubuntu:
  image: registry.gitlab.com/90cos/docker-definitions/basic-dev
  stage: build
  variables:
    TB_PATH: !reference [.c_update_path_and_get_google_test, variables, TB_PATH]
    GOOGLE_TEST: !reference [.c_update_path_and_get_google_test, variables, GOOGLE_TEST]
    C_PATH: C_Programming/bin_hex_string_to_integer
  script:
    - !reference [.c_build_compile_code_template, script]
  artifacts:
    paths:
      - ${C_PATH}/build/release/TestCode
      - $TB_PATH/$C_PATH/build/release/TestCode
    expire_in: 1 day
  rules:
    - if: $DEV == 'false'
      when: never
    - if: $DEV == 'true' && $UNIT_TEST_GROUP == "bridge_2"
      when: always
    - if: $CI_PROJECT_NAME == "basic-dev" && $UNIT_TEST_GROUP == "bridge_2"
      changes:
      - $TEST_BANK_PATH/C_Programming/bin_hex_string_to_integer/**/*
      - "$EVAL_FILES_DIR/**/*"
      - "global_job_templates.yml"

Test_C_Question_Bin_Hex_Str_to_Int_Ubuntu:
  image: registry.gitlab.com/90cos/docker-definitions/basic-dev
  stage: test
  variables:
    TB_PATH: !reference [.c_update_path_and_get_google_test, variables, TB_PATH]
    GOOGLE_TEST: !reference [.c_update_path_and_get_google_test, variables, GOOGLE_TEST]
    C_PATH: C_Programming/bin_hex_string_to_integer
  needs:
    - Build_C_Question_Bin_Hex_Str_to_Int_Ubuntu
  script:
    - !reference [.c_run_unit_tests_template, script]
  rules:
    - if: $DEV == 'false'
      when: never
    - if: $DEV == 'true' && $UNIT_TEST_GROUP == "bridge_2"
      when: always
    - if: $CI_PROJECT_NAME == "basic-dev" && $UNIT_TEST_GROUP == "bridge_2"
      changes:
      - $TEST_BANK_PATH/C_Programming/bin_hex_string_to_integer/**/*
      - "$EVAL_FILES_DIR/**/*"
      - "global_job_templates.yml"
